IMPLEMENTATION MODULE  DynString;

FROM pSTORAGE IMPORT ALLOCATE, DEALLOCATE;
FROM InOut IMPORT Read, Write,WriteString, EOL;
FROM SYSTEM IMPORT TSIZE;

(*TYPE StatStr = ARRAY [0..MaxStrLength] OF CHAR;
     DynStr = POINTER TO StatStr;*)

PROCEDURE length(S: ARRAY OF CHAR): INTEGER;
VAR i : INTEGER;
BEGIN
   i:=0;
   WHILE (i<= HIGH(S)) AND (S[i] >0C) DO INC(i) END(*WHILE*);
   RETURN i
END length;

PROCEDURE ReadDynStr(VAR S: DynStr);
(* Liest einen Dynamishen String mit InOut.ReadString.*)
VAR Buffer : StatStr;
    i      : INTEGER;
    Zeichen: CHAR;

BEGIN
    i:= 0 ;
    REPEAT
       Read(Zeichen); Buffer[i] := Zeichen; INC(i);
    UNTIL (i > MaxStrLength) OR (Zeichen = EOL);
    IF Zeichen = EOL THEN Buffer[i-1] := 0C; END(*IF*);
    MakeDynStr(Buffer,S);
END ReadDynStr;


PROCEDURE WriteDynStr(S: DynStr);
(* Gibt einen dynamischen String mit InOut.WriteString aus. Dadurch
   bleiben Ausgabeumleitungen wirksam. *)
VAR i : INTEGER;
BEGIN
   i:=0;
   IF (S#NIL) THEN
     WHILE S^[i] # 0C DO Write(S^[i]); INC(i); END(*WHILE*);
   END(*IF*);
END WriteDynStr;

PROCEDURE MakeDynStr(StatString : ARRAY OF CHAR; VAR S : DynStr);
(* Fertigt die dynamische Kopie eines statischen Strings an.
   Achtung: Falls S bereits einen Wert hatte ist dieser verloren! *)
VAR i, Store, Length : INTEGER;
BEGIN
   Length := length(StatString);
   Store:=(length(StatString)*TSIZE(CHAR) );
   ALLOCATE(S,Store);
   IF (S#NIL) THEN
     FOR i := 0 TO Length DO S^[i] := StatString[i]; END(*FOR*);
     S^[Length] := 0C;
   ELSE
     WriteString(" Out of Memory ");
     MemoryError := TRUE
   END(*IF*);
END MakeDynStr;



PROCEDURE MakeStatStr(VAR StatString : ARRAY OF CHAR; S : DynStr);
(* Kopiert einen dynamischen String in einen statischen. Falls der
   dynamische string zu lang ist wird der Rest abgeschnitten. *)
VAR i : INTEGER;
BEGIN
  IF (S#NIL) THEN
   FOR i := 0 TO length(S^) DO
       IF i>HIGH(StatString)
         THEN RETURN
         ELSE StatString[i] := S^[i];
       END(*IF*);
   END(*FOR*);
 ELSE
   StatString:="";
 END(*IF*);
END MakeStatStr;


PROCEDURE EraseDynStr(VAR S: DynStr);
(* Gibt den Speicherplatz wieder frei. nach dem Aufruf ist der Inhalt
   von S verloren.*)
VAR i, Store : INTEGER;
BEGIN
  IF (S#NIL) THEN
   Store:=(length(S^)*TSIZE(CHAR));
   DEALLOCATE(S,Store);
   S := NIL
  END(*IF*);
END EraseDynStr;

PROCEDURE DynStrLength(S : DynStr):INTEGER;
(* Liefert die Lnge eines Dynamischen Strings. *)
BEGIN
  IF (S#NIL) THEN
    RETURN length(S^)
  ELSE
    RETURN 0
  END(*IF*);
END DynStrLength;

PROCEDURE DynStrLess(S1, S2 : DynStr): BOOLEAN;
(* Vergleicht zwei dynamische Strings. wird TRUE wenn der S1
   im "ASCII-Zeichensatz" vor dem zweiten kommt. sonst FALSE. *)
VAR i : INTEGER;
BEGIN
  IF ((S1#NIL) AND (S2#NIL)) THEN
   i:=0;
   LOOP
      IF (S1^[i]=S2^[i]) AND (S1^[i] # 0C) THEN INC(i);
      ELSE RETURN S1^[i]<S2^[i]
      END(*IF*);
   END(*LOOP*);
 ELSE
   RETURN FALSE
 END(*IF*);
END DynStrLess;


PROCEDURE DynStrEqual(S1, S2 : DynStr): BOOLEAN;
(* Vergleicht zwei dynamische Strings. wird TRUE wenn  S1 = S2 *)
VAR i,j : INTEGER;
BEGIN
 IF ((S1#NIL) AND (S2#NIL)) THEN
   j:= DynStrLength(S1);
   IF DynStrLength(S2) # j THEN RETURN FALSE
   ELSE i:=0;
       WHILE (i<j) AND (S1^[i]=S2^[i]) DO INC(i); END(*WHILE*);
   END(*IF*);
   RETURN i=j
 ELSE
   RETURN FALSE
 END(*IF*);
END DynStrEqual;
BEGIN
   MemoryError := FALSE
END DynString.
