IMPLEMENTATION MODULE  Liste;

FROM SYSTEM IMPORT TSIZE;
FROM pSTORAGE IMPORT ALLOCATE,DEALLOCATE;
FROM DynString IMPORT DynStr,MakeDynStr, EraseDynStr, MakeStatStr;

TYPE List               = POINTER TO ListHeader;
     ListElementPointer = POINTER TO ListElement;
     ListHeader         = RECORD
                             current,
                             first,last : ListElementPointer;
                          END ;
     ListElement        = RECORD
                             next,prev     : ListElementPointer;
                             value         : DynStr;
                          END ;


PROCEDURE MakeList(VAR L:List);
BEGIN
   ALLOCATE(L,TSIZE(ListHeader));
   L^.first:=NIL;
   L^.last:=NIL;
   L^.current:=NIL;
END MakeList;

PROCEDURE KillList(VAR L:List);
VAR p,q:ListElementPointer;
BEGIN
    p:=L^.first;
    WHILE (p#NIL) DO
      q:=p;
      p:=p^.next;
      EraseDynStr(q^.value);
      DEALLOCATE(q,TSIZE(ListElement));
    END(*WHILE*);
    DEALLOCATE(L,TSIZE(ListHeader));
    L:=NIL
END KillList;

PROCEDURE First(VAR L:List);
BEGIN
    L^.current:=L^.first;
END First;

PROCEDURE Last(VAR L:List);
BEGIN
    L^.current:=L^.last;
END Last;

PROCEDURE Next(VAR L:List);
BEGIN
   IF (~Empty(L) AND (L^.current^.next # NIL))THEN
      L^.current:=L^.current^.next;
   END(*IF*);
END Next;

PROCEDURE Prev(VAR L:List);
BEGIN
   IF (~Empty(L) AND (L^.current^.prev # NIL))THEN
      L^.current:=L^.current^.prev;
   END(*IF*);
END Prev;

PROCEDURE Empty(VAR L:List):BOOLEAN;
BEGIN
   RETURN L^.first=NIL
END Empty;

PROCEDURE AtFirst(VAR L:List):BOOLEAN;
BEGIN
   RETURN L^.current=L^.first
END AtFirst;

PROCEDURE AtLast(VAR L:List):BOOLEAN;
BEGIN
   RETURN L^.current=L^.last
END AtLast;

PROCEDURE GetValue(VAR L:List;VAR Value :ARRAY OF CHAR):BOOLEAN;
VAR i:INTEGER;
BEGIN
   IF ~Empty(L) THEN
       IF L^.current^.value # NIL THEN
          MakeStatStr(Value,L^.current^.value);
          RETURN TRUE;
       END(*IF*);
   END(*IF*);
   RETURN FALSE;
END GetValue;

PROCEDURE SetValue(VAR L:List;Value :ARRAY OF CHAR);
VAR  i:INTEGER;
BEGIN
   IF ~Empty(L) THEN
       IF L^.current^.value = NIL THEN
          MakeDynStr(Value,L^.current^.value);
       ELSE
          EraseDynStr(L^.current^.value);
          MakeDynStr(Value,L^.current^.value);
       END(*IF*);
   END(*IF*);
END SetValue;

PROCEDURE EnterElement(VAR L:List);
VAR p,q :ListElementPointer;
BEGIN
  ALLOCATE(p,TSIZE(ListElement));
  IF (p#NIL) THEN
   p^.value := NIL;
   IF Empty(L) THEN
         L^.first:=p;
         L^.last:=p;
         p^.next:=NIL;
         p^.prev:=NIL;
   ELSIF AtFirst(L) THEN
         p^.next:=L^.first;
         L^.first:=p;
         p^.prev:=NIL;
         L^.current^.prev:=p;
   ELSE
         p^.next:=L^.current;
         p^.prev:=L^.current^.prev;
         q:=L^.current^.prev;
         q^.next:=p;
         L^.current^.prev:=p;
  END(*IF*);
  L^.current:=p;
 ELSE
   ListError:=TRUE
 END(*IF*);
END EnterElement;

PROCEDURE AppendElement(VAR L:List);
VAR p,q :ListElementPointer;
BEGIN
  ALLOCATE(p,TSIZE(ListElement));
  IF (p#NIL) THEN
   p^.value := NIL;
   IF Empty(L) THEN
         L^.first:=p;
         L^.last:=p;
         p^.next:=NIL;
         p^.prev:=NIL;
   ELSIF AtLast(L) THEN
         p^.prev:=L^.last;
         L^.last:=p;
         p^.next:=NIL;
         L^.current^.next:=p;
   ELSE
         p^.next:=L^.current^.next;
         p^.prev:=L^.current;
         q:=L^.current^.next;
         q^.prev:=p;
         L^.current^.next:=p;
  END(*IF*);
  L^.current:=p;
 ELSE
   ListError:=TRUE
 END(*IF*);
END AppendElement;

PROCEDURE RemoveElement(VAR L:List);
VAR p,q :ListElementPointer;
BEGIN
   IF ~Empty(L) THEN
   p:=L^.current;
   IF (AtFirst(L) AND AtLast(L)) THEN
       L^.first:=NIL;
       L^.last:=NIL;
       L^.current:=NIL;
   ELSIF AtFirst(L) THEN
       L^.first:=L^.current^.next;
       L^.first^.prev:=NIL;
       L^.current:=L^.current^.next;
   ELSIF AtLast(L) THEN
       L^.last:=L^.current^.prev;
       L^.last^.next:=NIL;
       L^.current:=L^.current^.prev;
   ELSE
       p^.prev^.next:=p^.next;
       p^.next^.prev:=p^.prev;
       L^.current:=L^.current^.next;
   END(*IF*);
   EraseDynStr(p^.value);
   DEALLOCATE(p,TSIZE(ListElement));
   END(*IF*);
END RemoveElement;

BEGIN
 ListError:= FALSE
END Liste.
